Subject: Re: gcc 3.11-2 link error with stdc++
From: "Dylan Cuthbert" <[email-masked]>
To: [email-masked]
Date: Mon, 15 Jul 2002 16:04:05 +0900
Newsgroups: gmane.os.cygwin

Ok, I've found the blighter...  after tracking down and splitting up the
code etc.  The reason is completely illogical mind you.

Since all this rather dodgy looking __gnu_cxx namespace stuff
(understandable for internal functions etc. but not for classes that are
used by Joe Punter) went into g++ 3.1 for classes that used to be called,
for example "std::hash_map",  I've been compiling with -D__gnu_cxx=std, now
I'd understand things were going wrong if std::string was in the __gnu_cxx
namespace but it isn't.  So I'm flummoxed with regards to finding a reason
for the error to occur.

I whittled it down to a single line that was writing a value into a
std::map<string, string> (not a hash_map which *is* in
__gnu_cxx_namespace_gubbins).  If I remove that line the file links without
the error in my previous mail below.

Very odd indeed, anyway, I'll package up the code and post it to the gnu
mailing list for more info.

Regards

---------------------------------
Q-Games, Dylan Cuthbert.
http://www.q-games.com

"egor duda" <[email-masked]> wrote in message
news:[email-masked]...
> Hi!
>
> Thursday, 11 July, 2002 Christopher Faylor [email-masked] wrote:
>
> CF> On Thu, Jul 11, 2002 at 08:58:42PM +0900, Dylan Cuthbert wrote:
> >>It seems any piece of code using string::replace with iterators causes a
> >>link error at the moment, this is the error I get:
> >>
> >> undefined reference to `
> >>std::basic_string<char, std::char_traits<char>, std::allocator<char>
> >>>::replace(std::__normal_iterator<char*, std::basic_string<char,
> >>std::char_traits<char>, std::allocator<char> > >,
> >>std::__normal_iterator<char*, std::basic_string<char,
> >>std::char_traits<char>, std::allocator<char> > >, unsigned, char)'
> >>collect2: ld returned 1 exit status
> >>
> >>If this isn't a cygwin-related problem I'll post to the gcc group,
however,
> >>I haven't seen mention of this kind of problem on there.
>
> CF> Sorry.  I can't offer any insight, especially without a test case, but
probably
> CF> not even then.
>
> CF> Maybe Egor might have an idea.
>
> Never seen this particular error. Dylan, maybe you can provide a
> testcase? You can also try to debug this error yourself by looking at
> files created with 'gcc -v -save-temps ...' and output of
> 'nm libstdc++.a'
>
> Egor.            mailto:[email-masked] ICQ 5165414 FidoNet 2:5020/496.19
>
>
> --
> Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
> Bug reporting:         http://cygwin.com/bugs.html
> Documentation:         http://cygwin.com/docs.html
> FAQ:                   http://cygwin.com/faq/
>
>

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/